declare GlobalStore in
%%%%%%%%%%%%%%%%%%%%%%%%%
% Link Module
%%%%%%%%%%%%%%%%%%%%%%%%%
   [GlobalStore]={Module.link ['./GlobalStore.ozf']}
%%%%%%%%%%%%%%%%%%%%%%%%%
%% Initiate a local store
%%%%%%%%%%%%%%%%%%%%%%%%%
declare NewObj LocalStore in
   try      
      {GlobalStore.newLocal "./globalstoreticket" user1  ?NewObj ?LocalStore}
   catch connectionfailed
   then
      {Show connectionfailed}
   end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Create three objects in the store
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
declare
   class Counter
      attr val
      meth show(Value) Value=@val end
      meth inc(Value) val <- @val+Value end
      meth init(Value) val <- Value end  
   end
   Obj1 Obj2 Obj3 in
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  Obj1, Obj2 Obj3 are  references
%  in LocalStore 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   Obj1={NewObj  Counter init(0)}
   Obj2={NewObj  Counter init(0)}
   Obj3={NewObj  Counter init(0)}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Save  Obj1 reference to use it on other local stores
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   {Pickle.save {Connection.offerUnlimited Obj1} './obj1globalref'}
   
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initiate   1000 transactions 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
declare Iterate in  
   fun {Iterate I}
      Transid Iteratebis  Trid  in
      if I\=0
      then      
	 {LocalStore begin_transaction(Obj1|Obj2|nil ?Transid)}
	 {Obj1 inc(1) Transid}
	 {Obj1 inc(~1) Transid}     
	 {Obj2 inc(~1) Transid}
	 {Obj2 inc(1) Transid}
	 {LocalStore end_transaction(Transid)}
	 Transid|{Iterate I-1}      
   else
	 nil
      end
   end
declare   Transset in
   Transset={Iterate 100}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Compute number of committed/aborted transactions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
declare Ccommit={NewCell 0} Cabort={NewCell 0} in
   {ForAll Transset 
    proc{$ Tr}
       if {LocalStore check_transaction(Tr $)}==commit
       then
	  {Assign Ccommit {Access Ccommit  $}+1}
       else
	  {Assign Cabort {Access Cabort $}+1}
       end
    end
   }
   {Show 'Number of local committed transaction:'#{Access Ccommit  $}}
   {Show 'Number of local aborted transaction:'#{Access Cabort  $}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Show a coherent snapshot of objects states 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
declare State1 State2 Trid in   
   {LocalStore begin_transaction(Obj1|Obj2|nil ?Trid)}
   {Obj1 show(State1) Trid}
   {Obj2 show(State2) Trid}
   {LocalStore end_transaction(Trid)}
   if {LocalStore check_transaction(Trid $)}==commit
   then
      {Show 'Obj1:'#State1#' Obj2:'#State2}
   end
   
	 



