%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Stationary Object Module
% Author: I.Alouini
% Last update: 10-4-00
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
functor 
import
export
   NewStatObj 
define
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Create a stationary object (asynchronous and synchronous)
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   proc {NewStatObj  Class Init ?AsynchStatObj ?SynchStatObj ?Obj}
   %S
   P%={NewPort S}
   in
      Obj={New Class Init}   
     % Fault is ressource 
     % StaObj is a mobile code: no reference to ressources
     % Todo:Get Fault Module  by functor to get local Fault ressource  
      proc {AsynchStatObj M}	
	 %GetFault=
	 %functor
	 %import
	 %   Module
	 %   Fault
	 %export
	 %   Fault
	 %define skip end	
	 %[FaultModule]={Module.apply [GetFault]}
	 %Fault=FaultModule.fault
      %in
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         % Only the interface to a watcher is implemented
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	 case M of
	    installwatcher(Conditions Proc Fault)
	 then
	    if {Fault.installWatcher P Conditions  Proc}==true then
	       skip
	    else
	       raise cannotinstallwatcher
	       end
	    end
	 [] deinstallwatcher(Proc Fault) then
	    if {Fault.deInstallWatcher P Proc}==true then
	       skip
	    else
	       raise deinstallwatcher end
	    end
	 [] installtempwatcher(Proc Fault) then
	    if {Fault.installWatcher P [tempFail]  Proc}==true then
	       skip
	    else
	       raise cannotinstallwatcher
	       end
	    end
	 else	    
	    try 
	       {Send P M}
	    catch _ then
	       raise senderror end
	    end
	 end
      end
      proc {SynchStatObj M}	
	 %GetFault=
	 %functor
	 %import
	 %   Module
	 %   Fault
	 %export
	 %   Fault
	 %define skip end	
	 %[FaultModule]={Module.apply [GetFault]}
	 %Fault=FaultModule.fault
      %in
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
         % Only the interface to a watcher is implemented
         %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	 case M of
	    installwatcher(Conditions Proc Fault)
	 then
	    if {Fault.installWatcher P Conditions  Proc}==true then
	       skip
	    else
	       raise cannotinstallwatcher
	       end
	    end
	 [] deinstallwatcher(Proc Fault) then
	    if {Fault.deInstallWatcher P Proc}==true then
	       skip
	    else
	       raise deinstallwatcher end
	    end
	 [] installtempwatcher(Proc Fault) then
	    if {Fault.installWatcher P [tempFail]  Proc}==true then
	       skip
	    else
	       raise cannotinstallwatcher
	       end
	    end
	 else	    
	    try
	       Synch in
	       {Send P M#Synch}
	       {Wait Synch}
	    catch _ then     
	       raise senderror end
	    end
	 end
      end
      thread
	 try S in
	    P={NewPort S}
	    {ForAll S
	     proc{$ Message}
		case Message of
		   M#Syn
		then 
		   {Obj M}
		   try 
		      Syn=true
		   catch _ % failure
		   then skip
		   end
		else
		   {Obj Message}
		end	
	     end
	    }
	 catch _ then skip end
      end   
   end
end


