%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Interface to Global Store
%%%% Last Update: 9-9-00
%%%% Author Ilies Alouini
%%%% @copyright UCL & Region Wallone              
%%%% Read LICENSE     
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
functor
import
   UserModule(newLocalStore:NewLocalStore) 
   ServerModule(serverClass:ServerClass) 
   StationaryObjectModule(newStatObj:NewStatObj)
   Connection
   Pickle
  export
   NewLocalStore
   New
   Getuniqueident
   
define
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Create a new global store
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%
   proc {New ?LocalStore}
      Server in      
      {StationaryObjectModule.newStatObj ServerModule.serverClass init(Server) Server _ _}
      try
	 {NewLocalStore Server 'virtualuser' _ _ ?LocalStore _ false}
	 %{LocalStore removeclient}
	 
      catch gs(connectionfailed)
      then
	 raise gs(failed_globalstore_creation) end
      end
   end
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%
   % Give an unique ident
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%
   proc {Getuniqueident Server ?Ident}
      try    	
	 {Server ping()}
	 Ident={Server getobjident($)}
      catch _
      then
	 %% the server reference is dead
	 %% will become alive after recovery
	 %% application will retry the connection with the new server
	 raise connectionfailed	       
	 end
      end
   end
   
end



